<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

function babelu_libAutoload($class)
{
	$flags = PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE;
	$directoryArray = preg_split('/(?=[A-Z])/', $class, null, $flags);
	$fileName = $directoryArray[(count($directoryArray) - 1)];
	$classPrefix = array_shift($directoryArray);
	
	if ($classPrefix === 'Babelu_lib')
	{
		$path_to_file = DIRECTORY_SEPARATOR;
		foreach ($directoryArray AS $dir)
		{
			if ($dir != $fileName)
			{
				$path_to_file .= strtolower($dir).DIRECTORY_SEPARATOR;
			}
		}
	
		$fileName = strtolower($fileName);
		$includePath = __DIR__.$path_to_file.$fileName.'.php';
		
		if (file_exists($includePath))
		{
			include_once ($includePath);
		}
	}
	
	return true;
}

class Babelu_libAutoloader
{
	public static function autoload($class)
	{
		babelu_libAutoload($class);
	}
}

spl_autoload_register(array('babelu_libautoloader','autoload'));