<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

class Babelu_libControllerJoomlaAdd extends Babelu_libControllerJoomlaDisplay
{
	/**
	 * Instantiate the controller.
	 *
	 * @param   JInput            $input  The input object.
	 * @param   JApplicationBase  $app    The application object.
	 * @param   array             $config Configuration
	 * @since  12.1
	 */
	public function __construct(JInput $input, $app = null, $config = array())
	{
		$input->set('layout', 'edit');
		
		parent::__construct($input, $app, $config);
	}
	
	public function execute()
	{
		$config = $this->config;
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		
		if (!$this->canDo($model,'core.create'))
		{
			$msg = $this->translate('JLIB_APPLICATION_ERROR_CREATE_RECORD_NOT_PERMITTED');
			$url = 'index.php?option='.$config['option'].'&task=display.'.$config['subject'];
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		parent::execute();
		return true;
	}
	
}
