<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

class Babelu_libControllerJoomlaCheckin extends Babelu_libControllerJoomlaBase
{
	public function execute()
	{
		//Check for request forgeries
		$this->validateSession();
		
		$config = $this->config;
		$url = 'index.php?option='.$config['option'].'&task=display.'.$config['subject'];
		
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		
		if (!$this->canDo($model))
		{
			$msg = $this->translate('BABELU_LIB_ERROR_CHECKIN_NOT_ALLOWED');
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		$input = $this->input;
		$cid = $input->post->get('cid', array(), 'array');
		// Make sure the item ids are integers
		$cid = $this->cleanCid($cid);
		

		try 
		{
			foreach ($cid AS $recordId)
			{
				$model->checkin($recordId);
			}
		}
		catch (Exception $e)
		{
			$msg = $e->getMessage();
			$this->setRedirect($url, $msg, 'warning');
			return false;
		}

		$msg = $this->translate('BABELU_LIB_MSG_CHECKIN_SUCCEEDED');
		$this->setRedirect($url, $msg, 'message');
		return true;
	}
}