<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

abstract class Babelu_libControllerJoomlaCreateBase extends Babelu_libControllerJoomlaSave
{
	public function execute()
	{
		//Check for request forgeries
		$this->validateSession();
		
		$config = $this->config;
		$url = 'index.php?option='.$config['option'].'&task=add.'.$config['subject'];
		
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		
		if (!$this->canDo($model,'core.create'))
		{
			$msg = $this->translate('BABELU_LIB_ERROR_CREATE_RECORD_NOT_PERMITTED');
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		try 
		{
			$input = $this->input;
			$data = $input->post->get('jform', array(), 'array');
			$keyName = $model->getKeyName();
			$data[$keyName] = 0;
			
			$this->commit($model, $data);
		}
		catch (Exception $e)
		{
			$this->setUserState();
			$msg = $e->getMessage();
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		return true;
		
	}
	
	protected function commit(Babelu_libModelJoomlaBase $model, $data)
	{
		$model->create($data);
	}
}

