<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

class Babelu_libControllerJoomlaPdfPreview extends Babelu_libControllerJoomlaPdfBase
{
	public function execute()
	{
		$prefix = $this->getPrefix();
		$config = $this->config;
		
		$model = $this->getModel($prefix, $config['subject'], $config);
		$keyName = $model->getKeyName();
		
		if (!array_key_exists($keyName, $config))
		{
			$config[$keyName] = 0;
		}
		
		$input = $this->input;
		$keyValue = $input->get($keyName, $config[$keyName], 'int');
		
		
		if (!$item = $model->getPdfItem($keyValue))
		{
			$msg = JText::_('BABLEU_LIB_ERROR_GETTING_PDF_ITEM');
			$url = 'index.php?option='.$config['option'].'&task=display.'.$config['subject'];
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		$config['layout'] = 'preview';
		$view = $this->getView($prefix, $config['subject'], 'pdf', $config);
		$view->setModel($config['subject'], $model, true);
		
		$output = $view->render();
		
		$pdfObject = $this->getPdfObject($config['subject'], $item->orientation, $item->format, $item->language);
		$pdfObject->writeHTML($output);
		$pdfObject->Output();
		
		$app = $this->app;
		$app->close();
	}
	
}