<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

abstract class Babelu_libControllerJoomlaState extends Babelu_libControllerJoomlaBase
{
	public function execute()
	{
		//Check for request forgeries
		$this->validateSession();
		
		$config = $this->config;
		$input = $this->input;
		
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		
		if (!$this->canDo($model, 'core.edit.state'))
		{
			throw new ErrorException($this->translate('JLIB_APPLICATION_ERROR_EDITSTATE_NOT_PERMITTED'));
			return false;
		}
		
		$cid = $input->post->get('cid', array(), 'array');
		// Make sure the item ids are integers
		$cid = $this->cleanCid($cid);
		
		
		$this->updateRecordState($model, $cid);
		
		return true;
	}
	
	/**
	 * Method to update record states
	 * @param array $cid primary keys
	 * @throws ErrorException
	 * @return void;
	 */
	abstract protected function updateRecordState(Babelu_libModelJoomlaBase $model, $cid);
	
	
}
