<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

abstract class Babelu_libControllerJoomlaUpdateBase extends Babelu_libControllerJoomlaSave
{
	
	public function execute()
	{
		//Check for request forgeries
		$this->validateSession();
		
		$config = $this->config;
		$input = $this->input;
		
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		$keyName = $model->getKeyName();
		$keyValue = $input->getInt($keyName);
		
		$url = 'index.php?option='.$config['option'].'&task=edit.'.$config['subject'];
		$url .='&'.$keyName.'='.$keyValue;
		
		if (!$this->canDo($model, 'core.edit'))
		{
			$msg = $this->translate('BABELU_LIB_ERROR_EDIT_RECORD_NOT_PERMITTED');
			$this->setRedirect($url, $msg, 'error');
			return false;
		}
		
		try 
		{
			$input = $this->input;
			$data = $input->post->get('jform', array(), 'array');
			$this->commit($model, $data);			
		}
		catch (Exception $e)
		{
			$this->setUserState();
			$msg = $e->getMessage();
			$this->setRedirect($url, $msg, 'error');
			return false;			
		}
		
		return true;
	}
	
	protected function commit(Babelu_libModelJoomlaBase $model, $data)
	{
		$model->update($data);
	}
	
	protected function checkin()
	{
		$config = $this->config;
		
		$prefix = $this->getPrefix();
		$model = $this->getModel($prefix, $config['subject'], $config);
		$keyName = $model->getKeyName();
		
		$input = $this->input;
		$keyValue = $input->getInt($keyName);
		
		$model->checkin($keyValue);
	
		return true;
	}
}

