<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

class Babelu_libControllerJoomlaUpdateCopy extends Babelu_libControllerJoomlaUpdateBase
{
	public function execute()
	{
		if (parent::execute())
		{
			$config = $this->config;
			
			$prefix = $this->getPrefix();
			$model = $this->getModel($prefix, $config['subject'], $config);

			$context = $model->getContext();
			$keyName = $model->getKeyName();
			$keyValue = $model->getState($context.'.id');
			
			$url = 'index.php?option='.$config['option'].'&task=edit.'.$config['subject'];
			$url .='&'.$keyName.'='.$keyValue;
			
			try
			{
				$this->checkin();
			}
			catch (Exception $e)
			{
				$msg = $e->getMessage();
				$this->setRedirect($url, $msg, 'warning', true, false);
			}
			
			$msg = $this->translate('BABELU_LIB_MSG_COPY_COMPLETED');
			$this->setRedirect($url, $msg, 'message');
			
			return true;
		}
		
		return false;
	}
	
	protected function commit(Babelu_libModelJoomlaBase $model, $data)
	{
		if (!$this->canDo($model, 'core.create'))
		{
			throw new ErrorException($this->translate('BABELU_LIB_ERROR_CREATE_RECORD_NOT_PERMITTED'));
		}
		else
		{
			$keyName = $model->getKeyName();
			$data[$keyName] = 0;
			
			$model->create($data);
		}
	}
}
