<?php
/**
 * @version     0.0.1
 * @package     Babel-U-Lib
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author     Mathew Lenning - http://mathewlenning.com/
 */
// No direct access
defined('_JEXEC') or die;

class Babelu_libViewJoomlaAdmin extends Babelu_libViewJoomlaBase
{
	// Edit Properties
	protected $item;
	protected $form;
	
	//List Properties
	protected $items;
	protected $editUrl;
	protected $pagination;
	protected $sidebar;
	protected $saveOrder;
	protected $canOrder;
	
	//Shared Properties
	protected $keyName;
	protected $formUrl;
	protected $state;
	
	
	public function render($tpl = null)
	{
		//get the unit count for each course
		$model = $this->getModel();
		$config = $this->config;
		
		$this->keyName = $model->getKeyName();
		
		if ($config['layout'] == 'edit')
		{
			JFactory::getApplication()->input->set('hidemainmenu', true);
			// load standard properties
			$this->item	= $model->getItem();
			$this->form	= $model->getForm($this->item, false);
		}
		else 
		{
			// load standard properties
			$this->items = $model->getItems();
			$this->formUrl = 'index.php?option='.$config['option'];
			$this->editUrl = 'index.php?option='.$config['option'].'&task=edit.'.$config['subject'].'&'.$this->keyName.'=';
			$this->pagination = $model->getPagination();
			
			$sideBarHelper = ucfirst(substr($config['option'], 4)).'HelperSidebar';
			
			if (class_exists($sideBarHelper))
			{
				$this->sidebar = $sideBarHelper::getSideBar($config['subject']);
				$this->addFilters();
			}
		}

		$this->state = $model->getState();
		
		// load toolbar
		$this->addToolbar($config);
		
		$this->addFilters();
		
		return parent::render($tpl);
	}
	
	protected function addToolbar($config)
	{
		$title = strtoupper($config['option'].'_header_'.$config['subject'].'_'.$config['layout']);
		$icon =  'babelu_lib.png';
		
		$toolbarUtility = new Babelu_libUtilityJoomlaToolbar();
		$this->buttons = $toolbarUtility->getButtons($config);
		
		$toolbarUtility->addToolBar($config['option'], $title, $icon, $this->buttons);
	}
	
	protected function addFilters()
	{
		
	}
	
	protected function getSortFields()
	{
		return array();
	}
	
}